#Использовать json

Перем Наименование Экспорт; // name
Перем Идентификатор Экспорт; // id
Перем ДатаИзмененияКлиент Экспорт; // client_modified
Перем ДатаИзмененияСервер Экспорт; // server_modified
Перем НомерВерсии Экспорт; // rev
Перем Размер Экспорт; // size
Перем Путь Экспорт; // path_lower
Перем ПутьПредставление Экспорт; // content_hash
Перем Хэш Экспорт; // path_display

Перем ДвочныеДанные Экспорт; // для хранения внутри данных при необходимости

Перем ПарсерJSON;

Процедура ПриСозданииОбъекта(пИдентификатор = Неопределено)
	
	Если ЗначениеЗаполнено(пИдентификатор) Тогда
		Идентификатор = пИдентификатор;
	КонецЕсли;

КонецПроцедуры

Процедура ЗаполнитьИзJSON(Знач ВходящиеДанные) Экспорт

	Если ТипЗнч(ВходящиеДанные) = Тип("Строка") Тогда

		Попытка
			ВходящиеДанные = ПарсерJSON.ПрочитатьJSON(ВходящиеДанные);
		Исключение
			ВызватьИсключение("Не удалось прочитать JSON, по причине: " + ОписаниеОшибки());
		КонецПопытки;
		
	КонецЕсли;

	Если ТипЗнч(ВходящиеДанные) <> Тип("Соответствие") Тогда
		ВызватьИсключение("Не удалось прочитать JSON. Входящие данные не соответствующий тип данных. Требует строка или соответствие.");
	КонецЕсли;

	ЭтотОбъект.Наименование = ВходящиеДанные.Получить("name");
	ЭтотОбъект.Идентификатор = ВходящиеДанные.Получить("id");
	ЭтотОбъект.ДатаИзмененияКлиент = ВходящиеДанные.Получить("client_modified");
	ЭтотОбъект.ДатаИзмененияСервер = ВходящиеДанные.Получить("server_modified");
	ЭтотОбъект.НомерВерсии = ВходящиеДанные.Получить("rev");
	ЭтотОбъект.Размер = ВходящиеДанные.Получить("size");
	ЭтотОбъект.Путь = ВходящиеДанные.Получить("path_lower");
	ЭтотОбъект.ПутьПредставление = ВходящиеДанные.Получить("path_display");
	ЭтотОбъект.Хэш = ВходящиеДанные.Получить("content_hash");

КонецПроцедуры

Функция Представление() Экспорт

	Соответвие = Новый Соответствие();
	Соответвие.Вставить("Наименование", Наименование);
	Соответвие.Вставить("Идентификатор", Идентификатор);
	Соответвие.Вставить("ДатаИзмененияКлиент", ДатаИзмененияКлиент);
	Соответвие.Вставить("ДатаИзмененияСервер", ДатаИзмененияСервер);
	Соответвие.Вставить("НомерВерсии", НомерВерсии);
	Соответвие.Вставить("Размер", Размер);
	Соответвие.Вставить("Путь", Путь);
	Соответвие.Вставить("ПутьПредставление", ПутьПредставление);
	Соответвие.Вставить("Хэш", Хэш);

	Возврат ПарсерJSON.ЗаписатьJSON(Соответвие);

КонецФункции

ПарсерJSON = Новый ПарсерJSON;